VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTextOutline"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' *********************************************************************
'  Copyright 1999 Karl E. Peterson, All Rights Reserved
'  http://www.mvps.org/vb
' *********************************************************************
'  Warning: This computer program is protected by copyright law and
'  international treaties. Unauthorized reproduction or distribution
'  of this program, or any portion of it, may result in severe civil
'  and criminal penalties, and will be prosecuted to the maximum
'  extent possible under the law.
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit

Private Declare Function BeginPath Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function EndPath Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long

Private Declare Function StrokeAndFillPath Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function StrokePath Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function FillPath Lib "gdi32" (ByVal hDC As Long) As Long

Private Declare Function GetBkMode Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hDC As Long, ByVal nBkMode As Long) As Long

' Background Modes
Private Const TRANSPARENT = 1
Private Const OPAQUE = 2

' Member variables
Private m_Filled As Boolean
Private m_hDC As Long
Private m_OutlineBehind As Boolean
Private m_Outlined As Boolean

' **************************************************************
'  Init/Term
' **************************************************************
Private Sub Class_Initialize()
   ' initialize props
   m_Filled = False
   m_Outlined = True
End Sub

Private Sub Class_Terminate()
   '
End Sub

' **************************************************************
'  Public Properties
' **************************************************************
Public Property Let Filled(ByVal NewVal As Boolean)
   m_Filled = NewVal
End Property

Public Property Get Filled() As Boolean
   Filled = m_Filled
End Property

Public Property Let hDC(ByVal NewVal As Long)
   m_hDC = NewVal
End Property

Public Property Get hDC() As Long
   hDC = m_hDC
End Property

Public Property Let OutlineBehind(ByVal NewVal As Boolean)
   m_OutlineBehind = NewVal
End Property

Public Property Get OutlineBehind() As Boolean
   OutlineBehind = m_OutlineBehind
End Property

Public Property Let Outlined(ByVal NewVal As Boolean)
   m_Outlined = NewVal
End Property

Public Property Get Outlined() As Boolean
   Outlined = m_Outlined
End Property

' **************************************************************
'  Public Methods
' **************************************************************
Public Sub DrawText(ByVal Text As String, ByVal X As Long, ByVal Y As Long)
   Static oldBkMode As Long
   Static nRet As Long
   
   If m_hDC Then
      oldBkMode = SetBkMode(m_hDC, TRANSPARENT)
      
      ' create the path within the DC
      Call BeginPath(m_hDC)
      Call TextOut(m_hDC, X, Y, Text, Len(Text))
      Call EndPath(m_hDC)
      
      If m_Outlined And m_Filled Then
         If m_OutlineBehind Then
            ' first draw the outline, then...
            Call StrokePath(m_hDC)
            ' recreate the path, then...
            Call BeginPath(m_hDC)
            Call TextOut(m_hDC, X, Y, Text, Len(Text))
            Call EndPath(m_hDC)
            ' fill the path.
            Call FillPath(m_hDC)
         Else
            Call StrokeAndFillPath(m_hDC)
         End If
      ElseIf m_Filled Then
         Call FillPath(m_hDC)
      ElseIf m_Outlined Then
         Call StrokePath(m_hDC)
      End If
      
      Call SetBkMode(m_hDC, oldBkMode)
   End If
End Sub

' **************************************************************
'  Private Methods
' **************************************************************
